import React, {Component} from 'react'
import PropTypes from 'prop-types'
import { Transfer } from 'antd'

import zhCN from '@/locales/zh-CN/share.js'
import enUS from '@/locales/en-US/share.js'
import './index.scss'

class TransferForm extends Component {
  static propTypes = {
    menulist: PropTypes.array
  }

  state = {
    dict: sessionStorage.getItem('lang') !== 'en-US' ? zhCN : enUS,
    targetKeys: [],
    selectedKeys: []
  }

  handleChange = (nextTargetKeys, direction, moveKeys) => {
    this.setState({ targetKeys: nextTargetKeys })
  }

  handleSelectChange = (sourceSelectedKeys, targetSelectedKeys) => {
    this.setState({ selectedKeys: [...sourceSelectedKeys, ...targetSelectedKeys] })
  }

  render() {
    const { targetKeys, selectedKeys, dict } = this.state

    return (
      <div className="trawmenutransfer">
        <Transfer
          dataSource={this.props.menulist}
          titles={[dict['thawmenu.source'], dict['thawmenu.target']]}
          targetKeys={targetKeys}
          locale={{itemUnit: dict['thawmenu.itemUnit'], itemsUnit: dict['thawmenu.itemsUnit']}}
          selectedKeys={selectedKeys}
          onChange={this.handleChange}
          onSelectChange={this.handleSelectChange}
          render={item => item.title}
        />
      </div>
    )
  }
}

export default TransferForm
